#include <stdint.h>
#include <string.h>
#include <stdbool.h>
#include "nrf.h"
#include "boards.h"
#include "clck_config.h"
#include "nrf_gzll.h"
#include "compression.h"
#include "nrf_delay.h"
#include "nrf_gpio.h"
#include "access_teds.h"

#define PIPE_NUMBER 2 

#define TX_PAYLOAD_LENGTH 24//20

//#define CHAR_OUTPUT

//#define COMPRESS_DATA

#define LCM_DEMO



// Data and acknowledgement payloads
static uint8_t data_payload[TX_PAYLOAD_LENGTH] = {0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00};              
static uint8_t ack_payload[NRF_GZLL_CONST_MAX_PAYLOAD_LENGTH]; 
static char char_value[2];
const uint8_t dummy_array_[10]={0x00,0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09};
uint8_t response_enum_;
// Debug helper variables
static volatile bool init_, init_ok, enable_ok, push_ok, pop_ok, tx_success;  
bool request_new_data_ = false;
bool data_ready_ = false;
bool tranmist_data_ = false;
bool sensor_connected_ = false;
void convertUint16ToChar(uint8_t* ptr_)
{
	char_value[0]= ptr_[0]&0xFF;
	char_value[1]= ptr_[1]>>8;
}

bool connectToHost()
{
	const uint8_t * temp_pointer_;
	temp_pointer_ = readUUID();
	init_ = nrf_gzll_init(NRF_GZLL_MODE_DEVICE);
	init_ = nrf_gzll_set_max_tx_attempts(100);	
	nrf_delay_ms(1000);
	memcpy(data_payload,temp_pointer_,10); // synchronisation packet is UUID of sensor
	init_ = nrf_gzll_add_packet_to_tx_fifo(PIPE_NUMBER, data_payload, TX_PAYLOAD_LENGTH);
	init_ = nrf_gzll_enable();
	return true;
}

void triggerResponse(uint8_t request_id_)
{
	const uint8_t * temp_pointer_; 
	switch(request_id_)
	{
		case 0x00:
			// connected to host
			data_ready_ = false;
			sensor_connected_ = true;
			break;
		case 0x01:
			// get the UUID of the node
		  temp_pointer_ = readUUID();
		  memcpy(data_payload,temp_pointer_,10);
			data_ready_ = true;
			break;
		case 0x02:
			temp_pointer_ = dummy_array_;
			memcpy(data_payload,temp_pointer_,sizeof(dummy_array_));
			data_ready_ = true;
			break;
		
	}	
	
}

/** @} */


/*****************************************************************************/
/** 
* @brief Main function. 
* 
* @return ANSI required int return type.
*/
/*****************************************************************************/
//lint -save -e514 Unusual use of a boolean expression (use of &= assignment).

int main()
{	
		/* initiate GPIO for PROTO13*/
		nrf_gpio_cfg_output(LED_0);/*LED_0 for PCA boards LED0 for PROTO13*/
		nrf_gpio_cfg_output(LED_1);
		//nrf_gpio_cfg_output(ANALOG_ENABLE);// comment out for PCA boards
		nrf_gpio_cfg_input(ADC_CONFIG_PSEL_AnalogInput2,0);
		nrf_gpio_cfg_input(ADC_CONFIG_PSEL_AnalogInput3,0);
		nrf_gpio_pin_set(LED_0);
		nrf_gpio_pin_set(LED_1);
		//nrf_gpio_pin_set(ANALOG_ENABLE); // comment out for PCA boards
	
		/*_*/
	
		/* initiate GAZELL*/
	  /*
		uint16_t current_adc_value;
    init_ok = nrf_gzll_init(NRF_GZLL_MODE_DEVICE);
    init_ok &= nrf_gzll_set_max_tx_attempts(100);
		init_ok &= nrf_gzll_set_timeslot_period(700UL);
		*/
		connectToHost();
		/*_*/
		
		//ADC_init();
		//hfclck_init();
		/* Compression */
		//init_compression();
		
		
		/*Send Communication Initialization Payload*/
		
		
		/*current_adc_value = getADCValue();
		current_adc_value = 0x0102;
		#ifdef CHAR_OUTPUT
    data_payload[0] = (char)current_adc_value&0xFF;
		data_payload[1] = (char)current_adc_value>>8;
		#else
	  data_payload[0] = current_adc_value&0xFF;
		data_payload[1] = current_adc_value>>8;
		#endif
    push_ok = nrf_gzll_add_packet_to_tx_fifo(PIPE_NUMBER, data_payload, TX_PAYLOAD_LENGTH);
    enable_ok = nrf_gzll_enable();
		*/
    while(1)
		{
			if(request_new_data_ == true)
			{
				request_new_data_ = false;
				#if defined LCM_DEMO
				triggerResponse(response_enum_); // function to fill data_payload
				//while(data_ready_!=1){}
				if (data_ready_ == true)
				{
					data_ready_ = false;
					push_ok = nrf_gzll_add_packet_to_tx_fifo(PIPE_NUMBER, data_payload, TX_PAYLOAD_LENGTH);	
				}
				#elif defined COMPRESS_DATA
				if(compressed_chunk_ready == true)
				{   
					compressed_chunk_ready = false;
					memcpy(data_payload,transmission_buffer,sizeof(transmission_buffer));
					push_ok = nrf_gzll_add_packet_to_tx_fifo(PIPE_NUMBER, data_payload, TX_PAYLOAD_LENGTH);
				}
				#endif
			}
			
		}
}



void  nrf_gzll_device_tx_success(uint32_t pipe, nrf_gzll_device_tx_info_t tx_info)
{
    uint32_t ack_payload_length = NRF_GZLL_CONST_MAX_PAYLOAD_LENGTH;    
    tx_success = true;
		#if defined LCM_DEMO
		response_enum_ = ack_payload[0];
		#elif defined COMPRESS_DATA
    start_Compression();
		#endif
		request_new_data_ = true;
}

void nrf_gzll_device_tx_failed(uint32_t pipe, nrf_gzll_device_tx_info_t tx_info)
{
    tx_success = false;
    push_ok = nrf_gzll_add_packet_to_tx_fifo(pipe, data_payload, TX_PAYLOAD_LENGTH);
}


void nrf_gzll_host_rx_data_ready(uint32_t pipe, nrf_gzll_host_rx_info_t rx_info)
{}
void nrf_gzll_disabled()
{}

/** @} */
/** @} */



